const { world, Button, UIElement, Vector, Color, Rotator, globalEvents, Card} = require('@tabletop-playground/api')

var mainCardStack = world.getObjectById("60m")

// CardHolder
var 
ch1 = world.getObjectById("ch1"),
ch1u = world.getObjectById("ch1u"),
ch2 = world.getObjectById("ch2"),
ch2u = world.getObjectById("ch2u"),
ch3 = world.getObjectById("ch3"),
ch3u = world.getObjectById("ch3u"),
ch4 = world.getObjectById("ch4"),
ch4u = world.getObjectById("ch4u"),
txtP1, txtP2, txtP3, txtP4,
stkDisOver = world.getObjectById("disOver")

// bind drop card
new Array(ch1, ch2, ch3, ch4).forEach((v)=>{
    v.onInserted = function(ch, card, player, index){
        card.onPrimaryAction = dropCard
    }
})

function newGame(){
    // collect all cards
    let targets = [ch1, ch1u, ch2, ch2u, ch3, ch3u, ch4, ch4u]
    for(let i = 0; i < targets.length; i++){
        let cards = targets[i].getCards()
        for(let j = 0; j < cards.length; j++) mainCardStack.addCards(cards[j],false,0,true)
    }
    mainCardStack.addCards(stkDisOver.takeCards(stkDisOver.getStackSize()-1,true), false, 0, true)
    
    // reset card stack
    mainCardStack.shuffle()
    
    // recover all ch to hidden mode
    targets = [ch1, ch2, ch3, ch4]
    targets.forEach((v)=>{ v.setHiddenCardsType(0)})
}

function drawCards(count, player){
    for(let i = 0; i < count; i++){
        let card = mainCardStack.takeCards()
        card.onPrimaryAction = dropCard
        player.getHandHolder().insert(card, player.getHandHolder().getNumCards())
        if(!card.isFaceUp()) card.flipOrUpright()
    }
}

function dropCard(card, player){
    let targetChu = null
    switch (player.getSlot()){
        case 0: targetChu = ch1u; break;
        case 1: targetChu = ch2u; break;
        case 2: targetChu = ch3u; break;
        case 3: targetChu = ch4u; break;
    }
    card.removeFromHolder()
    targetChu.insert(card,targetChu.getNumCards())
    setTimeout((c)=>{
        world.showPing(c.getPosition(), player.getPlayerColor(), false)
    }, 750, card)
}

function revealCards(btn, player){
    player.getHandHolder().setHiddenCardsType(2)
}

function checkChuOverflow(){
    let targets = [ch1u, ch2u, ch3u, ch4u], tarCards
    for(let chu of targets){
        if(chu.getNumCards() > 6) {
            tarCards = chu.getCards()
            for(let j = 0; j <= tarCards.length - 2; j++){
                tarCards[j].removeFromHolder()
                stkDisOver.addCards(tarCards[j], true, 0, true, true)
            }
        }
    }
}

// init Btns
var uie
var btnNewGame = new Button().setFontSize(15).setText("NewGame")
btnNewGame.onClicked.add(newGame)
uie = new UIElement()
uie.position = new Vector(60,-60,127.6)
uie.widget = btnNewGame
world.addUI(uie)

let btnShowCards = new Button().setFontSize(15).setText("Hu! / RevealMe")
btnShowCards.onClicked.add(revealCards)
uie = new UIElement()
uie.position = new Vector(55,-60,127.6)
uie.widget = btnShowCards
world.addUI(uie)

// init btns of  Draw, Show
let btnD1 = new Button().setFontSize(25).setText("Draw 1")
btnD1.onClicked.add((btn, player)=>{ drawCards(1, player) })
uie = new UIElement()
uie.position = new Vector(-15, -11, 127.6)
uie.widget = btnD1
world.addUI(uie)

let btnD4 = new Button().setFontSize(15).setText("Draw 4")
btnD4.onClicked.add((btn, player)=>{ drawCards(4, player) })
uie = new UIElement()
uie.position = new Vector(50, -60, 127.6)
uie.widget = btnD4
world.addUI(uie)

// Card Counters
txtP1 = new Text().setFontSize(15).setText("P1").setTextColor([0,0,0,1])
uie = new UIElement()
uie.position = new Vector(-70, 35, 127.6)
uie.widget = txtP1
world.addUI(uie)

txtP2 = new Text().setFontSize(15).setText("P2").setTextColor([0,0,0,1])
uie = new UIElement()
uie.position = new Vector(35, 70, 127.6)
uie.rotation = new Rotator(0, -90, 0)
uie.widget = txtP2
world.addUI(uie)

txtP3 = new Text().setFontSize(15).setText("P3").setTextColor([0,0,0,1])
uie = new UIElement()
uie.position = new Vector(70, -35, 127.6)
uie.rotation = new Rotator(0, -180, 0)
uie.widget = txtP3
world.addUI(uie)

txtP4 = new Text().setFontSize(15).setText("P4").setTextColor([0,0,0,1])
uie = new UIElement()
uie.position = new Vector(-35, -70, 127.6)
uie.rotation = new Rotator(0, 90, 0)
uie.widget = txtP4
world.addUI(uie)

setInterval(()=>{
    if(world.getPlayerBySlot(0)) txtP1.setText(ch1.getNumCards())
    if(world.getPlayerBySlot(1)) txtP2.setText(ch2.getNumCards())
    if(world.getPlayerBySlot(2)) txtP3.setText(ch3.getNumCards())
    if(world.getPlayerBySlot(3)) txtP4.setText(ch4.getNumCards())
    checkChuOverflow()
}, 750)


